#lang imperative-syndicate

(provide (struct-out ircd-listener)
         (struct-out ircd-motd)

         (struct-out ircd-connection-info)
         (struct-out ircd-channel)
         (struct-out ircd-channel-member)
         (struct-out ircd-channel-topic)
         (struct-out ircd-channel-user-count)

         (struct-out ircd-action)
         (struct-out ircd-event)

         lookup-nick)

;; A Connection is a TcpAddress

(assertion-struct ircd-listener (port))
(assertion-struct ircd-motd (lines))

(assertion-struct ircd-connection-info (conn nick user))
(assertion-struct ircd-channel (channel))
(assertion-struct ircd-channel-member (channel conn))
(assertion-struct ircd-channel-topic (channel topic))
(assertion-struct ircd-channel-user-count (channel count))

(message-struct ircd-action (conn message))
(message-struct ircd-event (conn message))

;;---------------------------------------------------------------------------

(define (lookup-nick conn)
  (immediate-query [query-value #f (ircd-connection-info conn $N _) N]))
